import java.applet.*;
import java.awt.*;

public class Struna extends Applet
{
  Beh beh;
  Vypocet vyp;
  boolean ss = true;

  Label lpauza, lpruznost, lpocet, ldisipace, lvlna, lemitace, ldistance;
  Button tlstart, tlsrovnej;
//  Scrollbar sbpauza, sbpruznost, sbpocet;
  TextField tfpauza, tfpruznost, tfpocet, tfdisipace, tfdistance;
  CheckboxGroup cbgokrajl, cbgokrajp;
  Checkbox cbokrajlp, cbokrajlv, cbokrajpp, cbokrajpv;
  Choice cvlny, cemitor;
  Checkbox cbsmycka;
  
  final int MAXY = 200;
  int MAXX = 600;
  final int OFFS = 100;

  public Struna() {
  }

  public void init() {
    int mx = new Integer(getParameter("XSIZE")).intValue();
    if (mx >= 600) MAXX = mx;
    setLayout(null);
    setSize(MAXX, MAXY);
    vyp = new Vypocet(this, MAXX, MAXY-OFFS, 0, OFFS);
    beh = new Beh(vyp);

    lpauza = new Label("Pauza");
    lpruznost = new Label("Prunost");
    lpocet = new Label("Poet");
    ldisipace = new Label("Tlumen");
    lvlna = new Label("Vlna");
    lemitace = new Label("Emitace");
    ldistance = new Label("Napt");
    tlstart = new Button();
    tlstart.setLabel("Stop");
    tlsrovnej = new Button();
    tlsrovnej.setLabel("Srovnat");
//    sbpauza = new Scrollbar(Scrollbar.HORIZONTAL, 100, 50, 5, 500);
//    sbpruznost = new Scrollbar(Scrollbar.HORIZONTAL, 1000, 10, 0, 1000);
//    sbpocet = new Scrollbar(Scrollbar.HORIZONTAL, 20, 10, 2, 300);
    tfpauza = new TextField("50", 50);
    tfpruznost = new TextField("1", 50);
    tfpocet = new TextField("20", 50);
    tfdisipace = new TextField("1", 50);
    tfdistance = new TextField("0", 50);
    cbgokrajl = new CheckboxGroup();
    cbgokrajp = new CheckboxGroup();
    cbokrajlp = new Checkbox("Pevn konec", cbgokrajl, true);
    cbokrajlv = new Checkbox("Voln konec", cbgokrajl, false);
    cbokrajpp = new Checkbox("Pevn konec", cbgokrajp, true);
    cbokrajpv = new Checkbox("Voln konec", cbgokrajp, false);
    cvlny = new Choice();
    cvlny.addItem("Trojhelnk");
    cvlny.addItem("Sinus");
    cvlny.addItem("Obdlnk");
    cvlny.addItem("Pechod");
    cemitor = new Choice();
    cemitor.addItem("Trojhelnk");
    cemitor.addItem("Sinus");
    cemitor.addItem("Obdlnk");
    cbsmycka = new Checkbox("Smyka", false);

    lpauza.setBounds(0, 0, 50, 20);
    lpruznost.setBounds(0, 20, 50, 20);
    lpocet.setBounds(0, 40, 50, 20);
    ldisipace.setBounds(150, 0, 50, 20);
    ldistance.setBounds(150, 20, 50, 20);
    lvlna.setBounds(MAXX-150, 0, 50, 20);
    lemitace.setBounds(MAXX-150, 20, 50, 20);
//    sbpauza.setBounds(0, 0, 200, 20);
//    sbpruznost.setBounds(0, 20, 200, 20);
//    sbpocet.setBounds(0, 40, 200, 20);
    tfpauza.setBounds(50, 0, 100, 20);
    tfpruznost.setBounds(50, 20, 100, 20);
    tfpocet.setBounds(50, 40, 100, 20);
    tfdisipace.setBounds(200, 0, 100, 20);
    tfdistance.setBounds(200, 20, 100, 20);
    tlstart.setBounds(320, 0, 100, 20);
    tlsrovnej.setBounds(320, 20, 100, 20);
    cbokrajlp.setBounds(0, 60, 100, 20);
    cbokrajlv.setBounds(0, 80, 100, 20);
    cbokrajpp.setBounds(MAXX-100, 60, 100, 20);
    cbokrajpv.setBounds(MAXX-100, 80, 100, 20);
    cvlny.setBounds(MAXX-100, 0, 100, 20);
    cemitor.setBounds(MAXX-100, 20, 100, 20);
    cbsmycka.setBounds(MAXX-100, 40, 100, 20);
   

    add(lpauza);
    add(lpruznost);
    add(lpocet);
    add(ldisipace);
    add(lvlna);
    add(lemitace);
    add(ldistance);
//    add(sbpauza);
//    add(sbpruznost);
//    add(sbpocet);
    add(tfpauza);
    add(tfpruznost);
    add(tfpocet);
    add(tfdisipace);
    add(tfdistance);
    add(tlstart);
    add(tlsrovnej);
    add(cbokrajlp);
    add(cbokrajlv);
    add(cbokrajpp);
    add(cbokrajpv);
    add(cvlny);
    add(cemitor);
    add(cbsmycka);
  }

  public void start() {
    beh.start();
  }

  public void stop() {
    beh.stop();
  }

  public void paint() {
    vyp.kresli();
  }

/*
  public boolean handleEvent(Event evt) {
    if (evt.target == sbpauza) {
      beh.setPause(sbpauza.getValue());
    }

    if (evt.target == sbpruznost) {
      vyp.setPruznost((double)sbpruznost.getValue()/1000);
    }

    if (evt.target == sbpocet) {
      vyp.setPocet(sbpocet.getValue());
    }
    return true;
  }
*/

  public boolean action(Event evt, Object obj) {

    if (evt.target == tlsrovnej) {
      vyp.srovnej();
    }

    if (evt.target == tlstart) {
      if (ss) tlstart.setLabel("Start");
      else tlstart.setLabel("Stop");
      if (ss) ss = false;
      else ss = true;
      beh.setBeh(ss);
    }

    if (evt.target == tfpauza) {
      int i = new Integer((String)obj).intValue();
      if (i >= 0) beh.setPause(i);
    }

    if (evt.target == tfpruznost) {
      double d = new Double((String)obj).doubleValue();
      if ((d > 0) && (d <= 1)) vyp.setPruznost(d);
    }

    if (evt.target == tfpocet) {
      int i = new Integer((String)obj).intValue();
      if ((i > 3) && (i <= 300)) vyp.setPocet(i);
    }

    if (evt.target == tfdisipace) {
      double d = new Double((String)obj).doubleValue();
      if ((d > 0) && (d <= 1)) vyp.setDisipace(d);
    }

    if (evt.target == tfdistance) {
      double d = new Double((String)obj).doubleValue();
      vyp.setD0(d);
    }

    if (evt.target == cbokrajlp) {
      vyp.setOkrajL(1);
    }

    if (evt.target == cbokrajlv) {
      vyp.setOkrajL(2);
    }

    if (evt.target == cbokrajpp) {
      vyp.setOkrajP(1);
    }

    if (evt.target == cbokrajpv) {
      vyp.setOkrajP(2);
    }

    if (evt.target == cvlny) {
      if ((String)obj == "Sinus") vyp.modifikace(1);
      if ((String)obj == "Trojhelnk") vyp.modifikace(2);
      if ((String)obj == "Obdlnk") vyp.modifikace(3);
      if ((String)obj == "Pechod") vyp.modifikace(4);
    }

    if (evt.target == cemitor) {
      if ((String)obj == "Trojhelnk") vyp.setEmitace(true, 1);
      if ((String)obj == "Sinus") vyp.setEmitace(true, 2);
      if ((String)obj == "Obdlnk") vyp.setEmitace(true, 3);
    }

    if (evt.target == cbsmycka) {
      vyp.swapSmycka();
    }

    return true;
  }
}
